## mingw-w64-openturns-1.23-3.src.tar.zst

=== lib/CMakeLists.txt ===
#                                               -*- cmake -*-

# Recurse in subdirectories
add_subdirectory (include)
add_subdirectory (src)
add_subdirectory (etc)

# Build the OpenTURNSConfig.cmake file
set (OPENTURNS_LIBRARY_DIRS            ${LIBRARY_PATH})
set (OPENTURNS_LIBRARY                 OT)
list (APPEND OPENTURNS_LIBRARIES       ${OPENTURNS_LIBRARY})
set (OPENTURNS_INCLUDE_DIR             ${INCLUDE_PATH})
list (INSERT OPENTURNS_INCLUDE_DIRS 0  ${OPENTURNS_INCLUDE_DIR})

set (OPENTURNS_ROOT_DIR       ${INSTALL_PATH})
set (OPENTURNS_VERSION_STRING ${PACKAGE_VERSION})
set (OPENTURNS_VERSION_MAJOR  ${CPACK_PACKAGE_VERSION_MAJOR})
set (OPENTURNS_VERSION_MINOR  ${CPACK_PACKAGE_VERSION_MINOR})
set (OPENTURNS_VERSION_PATCH  ${CPACK_PACKAGE_VERSION_PATCH})

include(CMakePackageConfigHelpers)
configure_package_config_file (OpenTURNSConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
  INSTALL_DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH}
  PATH_VARS
    OPENTURNS_ROOT_DIR
    OPENTURNS_INCLUDE_DIR
    OPENTURNS_INCLUDE_DIRS
    OPENTURNS_LIBRARY_DIRS
    OPENTURNS_SWIG_INCLUDE_DIRS
    PYTHON_MODULE_PATH
  NO_CHECK_REQUIRED_COMPONENTS_MACRO)

write_basic_package_version_file(OpenTURNSConfigVersion.cmake VERSION ${OPENTURNS_VERSION_STRING} COMPATIBILITY AnyNewerVersion)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfigVersion.cmake
         DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH})

# Recurse in subdirectories : test should be run after src (for target OT to be built)
add_subdirectory (test)

if (DOXYGEN_FOUND)

  # generate Doxyfile
  set (VERSION ${PACKAGE_VERSION})
  set (builddir ${CMAKE_CURRENT_BINARY_DIR})
  set ( top_srcdir ${CMAKE_CURRENT_SOURCE_DIR})
  configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
                   ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
                    @ONLY)

  # generate html doc and compress it
  add_custom_target (html 
                      COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/doc
                      COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
                      COMMAND tar czf doc-api-${PACKAGE_VERSION}.tar.gz doc
                      COMMAND tar cjf doc-api-${PACKAGE_VERSION}.tar.bz2 doc
                     )

endif ()

install (FILES ${HEADERFILES} DESTINATION ${OPENTURNS_INCLUDE_PATH}/openturns)

=== lib/src/Uncertainty/Algorithm/MetaModel/LinearModel/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()


ot_add_source_file (LinearModelResult.cxx)
ot_add_source_file (LinearModelAlgorithm.cxx)
ot_add_source_file (LinearModelStepwiseAlgorithm.cxx)
ot_add_source_file (LinearModelAnalysis.cxx)

ot_install_header_file (LinearModelResult.hxx)
ot_install_header_file (LinearModelAlgorithm.hxx)
ot_install_header_file (LinearModelStepwiseAlgorithm.hxx)
ot_install_header_file (LinearModelAnalysis.hxx)

ot_install_header_file (OTLinearModel.hxx)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=openturns
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.23
pkgrel=3
pkgdesc="Uncertainty treatment library (mingw-w64)"
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://openturns.github.io/www"
msys2_repository_url="https://github.com/openturns/openturns"
msys2_references=(
  'aur: openturns'
)
license=('spdx:LGPL-3.0-only')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-ceres-solver"
         "${MINGW_PACKAGE_PREFIX}-glog"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git"
         "${MINGW_PACKAGE_PREFIX}-mpc"
         "${MINGW_PACKAGE_PREFIX}-mpfr"
         "${MINGW_PACKAGE_PREFIX}-muparser"
         "${MINGW_PACKAGE_PREFIX}-nlopt"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-python-dill"
         "${MINGW_PACKAGE_PREFIX}-python-psutil"
         "${MINGW_PACKAGE_PREFIX}-tbb")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-spectra"
             "${MINGW_PACKAGE_PREFIX}-swig")
source=("https://github.com/openturns/openturns/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "001-fix-default-site-packages.patch")
sha256sums=('4c7cfe5d2310933e3a2e91f7db9531d80e32157143157df80f6e93267c29f414'
            'd62063cb3ac4857b3882ead29727df8414e47de0b8be7d915db5b1a7a6aea339')

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  # https://github.com/openturns/openturns/pull/2005
  patch -p1 -i "${srcdir}"/001-fix-default-site-packages.patch
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  local -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  CXXFLAGS+=" -Wno-deprecated-declarations" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=;-DOPENTURNS_DOC_PATH=" \
  ${MINGW_PREFIX}/bin/cmake.exe -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
    -DOPENTURNS_DOC_PATH=${MINGW_PREFIX}/share/licenses/${_realname} \
    -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    -DUSE_SPHINX=OFF \
    "${_extra_config[@]}" \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="$pkgdir" ${MINGW_PREFIX}/bin/cmake --install .

  MSYS2_ARG_CONV_EXCL="-p" python -m compileall \
    -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}${MINGW_PREFIX}/lib/python"*

  local PREFIX_MINGW=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_MINGW}|\${PACKAGE_PREFIX_DIR}|g" \
    -i "$pkgdir${MINGW_PREFIX}/lib/cmake/${_realname}/OpenTURNSConfig.cmake"
  find "$pkgdir${MINGW_PREFIX}/lib/cmake/${_realname}" -name '*.cmake' -exec \
    sed -s "s|${PREFIX_MINGW}|\$\{_IMPORT_PREFIX\}|g" -i {} \;

  local PREFIX_MSYS2=$(cygpath -am /)
  sed -s "s|${PREFIX_MSYS2::-1}||g" \
    -i "$pkgdir${MINGW_PREFIX}/lib/cmake/${_realname}/OpenTURNSConfig.cmake"
}

=== distro/debian/control ===
Source: openturns
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Denis Barbier <barbier@debian.org>,
           Pierre Gruet <pgt@debian.org>
Build-Depends: debhelper-compat (= 12),
               bison,
               cmake,
               coinor-libipopt-dev,
               dh-python,
               gfortran,
               flex,
               libblas-dev,
               libboost-math-dev,
               libceres-dev,
               libcminpack-dev,
               libdlib-dev,
               libhdf5-dev,
               liblapack-dev,
               libmpc-dev,
               libmpfr-dev,
               libmuparser-dev,
               libnlopt-cxx-dev,
               libpagmo-dev,
               libpng-dev,
               libprimesieve-dev,
               libsqlite3-dev,
               libspectra-dev,
               libtbb-dev,
               libxml2-dev,
               libnanoflann-dev,
               libcuba-dev,
               python3-dev,
               swig
Standards-Version: 4.6.0
Homepage: https://openturns.github.io/www/
Vcs-Browser: https://salsa.debian.org/science-team/openturns
Vcs-Git: https://salsa.debian.org/science-team/openturns.git
Rules-Requires-Root: no

Package: libopenturns0.24
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         openturns-common
Suggests: python3-openturns
Description: dynamic libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * define the outputs of interest and decision criteria;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package provides the dynamic libraries.

Package: libopenturns-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libceres-dev,
         libopenturns0.24 (= ${binary:Version})
Description: headers and development libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package contains development files needed to build OpenTURNS applications.

Package: openturns-common
Architecture: all
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: generic tool to treat and quantify uncertainties (common files)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package contains the configuration file for the versioned library
 package.

Package: python3-openturns
Section: python
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libopenturns0.24 (= ${binary:Version}),
         ${python3:Depends}
Provides: ${python3:Provides}
Suggests: python3-matplotlib,
          python3-scipy
Description: Python3 front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.
 .
 This package provides the Python3 bindings to the library.
